/* Header defining data structures for AST types. */

#ifndef __asttypes_h__
#define __asttypes_h__

enum { /* Address types. */
	AT_INVALID = 0,
	AT_LABELREL,
	AT_PCREL,
	AT_ABSOLUTE
};

struct Address {
	int type;
	int label;
	int offset;
    int absolute;
	char *tostring;
};

typedef struct Address *Address;

enum { /* Statement types */
	ST_INVALID = 0,
	ST_SBN = 1,
	ST_VARDECL = 2
};

struct Stmt {
	int type;
	int addr;
	int label;

	Address lhs;
	Address rhs;
	Address branchdest;

	int value;
};

typedef struct Stmt *Stmt;

struct StmtList {
	Stmt car;
	struct StmtList *cdr;
};

typedef struct StmtList *StmtList;


#endif /* __asttypes_h__ */
