/* Lexical analyzer for SBN interpreter. */

%option noyywrap

%{ 

#include "asttypes.h"
#include "sbn-parse.tab.h"

extern int intern_tolower(char *outside);

%}

%% 

[ \t\r\n]+           { /* whitespace ignored */ }
\#.*$                { /* comments ignored */ }
[0-9][0-9]*          { yylval.I = atoi(yytext); return DEC_CONST; }
[\:,\.\-\+]          { return yytext[0]; }
\.[wW][oO][rR][dD]   { return DOT_WORD; }
[sS][bB][nN]         { return SBN; }
[A-Za-z][A-Za-z0-9]* { yylval.I = intern_tolower(yytext); return ID; }

%%
